[参考链接](https://suan.eu.org/post/clash-%E6%95%99%E7%A8%8B/ "参考链接")
主要步骤为：
- 下载clash的二进制可执行文件：[官网](https://github.com/Dreamacro/clash/releases/ "官网")

```bash
wget https://github.com/Dreamacro/clash/releases/download/v0.16.0/clash-linux-amd64-v0.16.0.gz
```
- 解压，移动文件，添加可执行权限：

```bash
gzip -d clash-linux-amd64-v0.16.0.gz
mv clash-linux-amd64-v0.16.0 /usr/local/bin/clash  #这个clash是文件，不是文件夹，将clash-linux-amd64-v0.16.0 重命名为clash
chmod +x /usr/local/bin/clash
```
- 执行测试,确保能够运行

```bash
cd /usr/local/bin/
./clash
```
- 将clash设置成linux服务，编写服务配置文件

```bash
vim /etc/systemd/system/clash.service
```
- 服务配置文件脚本（直接复制）

```bash
[Unit]
Description=clash service
After=network.target

[Service]
Type=simple
User=root
ExecStart=/usr/local/bin/clash
Restart=on-abort # or always, on-abort, etc

[Install]
WantedBy=multi-user.target
```

- 启动、关闭、查看服务状态的命令

```bash
systemctl daemon-reload  #重新加载服务模块（配置新服务后先执行）
systemctl enable clash   #设置clash服务开机重启

service clash start      #启动clash服务（也可以用systemctl启动：systemctl start clash）
service clash status     #查看clash服务状态
```

- config.yaml配置（一般是买的）
把生成的yaml文件装入，放置到linux服务的配置文件指定目录（~/.config/clash）,启动这个服务就会自动生成：
![](http://33521.wang:8181/uploads/202303/mindoc/attach_174d208ab3641e2c.png)

- 在bash命令下配置开启代理
可以设置临时在命令窗口加载，也可以设置永久加载（写到当前用的.bashrc文件中）

```bash
vim ~/.bashrc
#文件最后一行写入：
export https_proxy=http://127.0.0.1:7890 http_proxy=http://127.0.0.1:7890 all_proxy=socks5://127.0.0.1:7891
source ~/.bashrc
```
![](http://33521.wang:8181/uploads/202303/mindoc/attach_174d2630ea26607b.png)

- 查看代理详情，可直接：[clash的代理页面](https://clash.razord.top/#/proxies "clash的代理页面")操作，输入ip、端口、校验字符串。
ip:主要是服务器部署的ip（公网）
端口、校验字符串：主要是在上述config.yaml文件中，如下：
![](http://33521.wang:8181/uploads/202303/mindoc/attach_174d26ade3325ce5.png)


------------


> 写在最后：
这个东西属于**术**的层面，它不会让你掌握非常多有用的技术，支撑、进化成为你赖以生存的技能。写这些的目的主要是**资源整合**、接合自己部署时遇到的坑予以记录。一方面加深印象、另一方面方便下次使用，提高效率。
同时，这个东西很杂，非必要不掌握，记录一遍最好忘记，有印象就行