#### C++20格式化字符串
总结：
- 使用只读的std::string_view来读取字符串，提高效率
- 使用20的格式化字符串功能：std::vformat
- 对可变参数进行字符串格式化：std::make_format_args

需要深入理解的点：
- 格式化的规则都有哪些，如{}，其它规则都是什么?
- 可变参数如何解析？除了递归调用，有没有其它方法


```cpp
std::string msg = "123{},{}";
std::string_view fmt(msg);   //只读的字符串视图，主要是保存字符的index等信息，无法修改

template <typename... T>
void debug(std::string_view fmt,T&&... arg)
{
	const auto& msg = std::vformat(fmt, std::make_format_args(arg...));
	//c++20的格式化字符串
}

```

#### C++20 requires关键字
[参考链接](https://zhuanlan.zhihu.com/p/516734341 "参考链接")